#include "ot4xb.ch"

#INCLUDE "AppEvent.CH"
#INCLUDE "xbp.CH"

#define xbeSD_Arrive                xbeP_User + 1
#define xbeSD_Remove                xbeP_User + 2

#define WM_DEVICECHANGE             0x0219
#define DBT_DEVICEARRIVAL           0x8000  // A device or piece of media has been inserted and is now available.
#define DBT_DEVICEQUERYREMOVE       0x8001  // Permission is requested to remove a device or piece of media. Any application can deny this request and cancel the removal.
#define DBT_DEVICEREMOVECOMPLETE    0x8004  // A device or piece of media has been removed.

PROCEDURE AppSys
RETURN

PROCEDURE MAIN()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL lExit  := .F.
LOCAL aSize  := {640,480}
LOCAL cUser  := Getenv("USERPROFILE")
LOCAL cStart := cUser+"\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup\ARRIVE.LNK"

   IF !FILE(cStart)
      MakeLnk(cStart)
   ENDIF

   oDlg := XbpDialog():New(AppDesktop(),,,aSize,, .F. )
   oDlg:taskList := .T.
   oDlg:title := "USB_Auto "
   oDlg:Icon := 1
   oDlg:close := { || lExit := .T. }
   oDlg:maxButton := .F.
   oDlg:minButton := .F.
   oDlg:Border := XBPDLG_NO_BORDER
   oDlg:Create()
   CenterControl( oDlg )

   delegated_eval( { || ot4xb_CreateGenericWindow( MyVolHandler( oDlg ) ) } )

   oDlg:show()
   SETAPPFOCUS( oDlg )

   nEvent := xbe_None
   DO WHILE .NOT. lExit = .T.
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            lExit := .T.
         CASE nEvent == xbeSD_Arrive
            Msgbox("xbeSD_Arrive")
         CASE nEvent == xbeSD_Remove
            Msgbox("xbeSD_Remove")
         OTHERWISE
            oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO
   oDlg:Destroy()

RETURN

* -------------------------------------------------------------------------- *

CLASS MyVolHandler

EXPORTED:

   CLASS VAR oMain

INLINE CLASS METHOD wndproc( hWnd, nMsg, wp, lp, ctx )

   IF nMsg == WM_DEVICECHANGE
      DO CASE
         CASE wp == DBT_DEVICEARRIVAL
            PostAppEvent(xbeSD_Arrive,,,::oMain)
         CASE wp == DBT_DEVICEQUERYREMOVE

         CASE wp == DBT_DEVICEREMOVECOMPLETE
            PostAppEvent(xbeSD_Remove,,,::oMain)
      ENDCASE
      RETURN NIL
   ENDIF
RETURN NIL

ENDCLASS

* -------------------------------------------------------------------------- *

STATIC FUNCTION MakeLnk(cLinkFile)
LOCAL cWorkingDir := CURDRIVE()+":\"+CURDIR()+"\"
LOCAL cLinkTarget := CURDRIVE()+":\"+CURDIR()+"\ARRIVE.EXE"     // EXE, BAT
LOCAL cCmdArgs    := "DELAY"                                    // Parameter
LOCAL cDescr      := "USB Autorun Drive Control"                // Description
LOCAL cHotKey     := ""                                         // UPPER( A - Z )
LOCAL aIcon       := { AppName(.T.), 0 }                        // { FullpathName, Index }
LOCAL nConfirm

   nConfirm := ConfirmBox(      , ;                         // oOwner
                           cLinkFile+CRLF+;
                           "create Auto-Start LNK ?", ;     // cText
                           "Startup Config", ;        // cTitle
                           XBPMB_YESNO, ;
                           XBPMB_QUESTION + XBPMB_APPMODAL + XBPMB_MOVEABLE )

   IF nConfirm = XBPMB_RET_YES
#IFDEF Use_DXE
      DXE_CreateLink(cLinkTarget,cLinkFile,cWorkingDir,cCmdArgs,cDescr,;
                     cHotKey,aIcon)
#ELSE
      ShellLinkCreate(cLinkTarget,cLinkFile,cWorkingDir,cCmdArgs,cDescr )
#ENDIF
   ENDIF

RETURN NIL


*
*
*